<?php
/*
 * Plugin Name: tigaman webdesin - User Info
 * Plugin URI: https://www.tigaman.com/
 * Description: tigaman webdesign - This plugin displays the user info on the website in a widget
 * Version: 1.0
 * Author: tigaman webdesign
 * Author URI: https://www.tigaman.hu/
 */
?>
<?php
register_activation_hook(__FILE__, 'twd_user_info_install');
function twd_user_info_install()
{
    global $wpdb;
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $sql = 'CREATE TABLE ' . $twd_user_info_table . ' (
  ip int(20) NOT NULL default \'0\',
  user_id bigint(20) default NULL,
  botname varchar(255) NOT NULL default \'\',
  path varchar(255) NOT NULL default \'\',
  first_visit bigint(20) NULL default NULL,
  last_visit bigint(20) NULL default NULL,
  view_count bigint(20) NOT NULL default \'0\',
  PRIMARY KEY (ip)
);';
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    add_option('twd_user_info_version', '0.1.5');
    add_option('twd_user_info_time_before_off', '5');
}

register_deactivation_hook(__FILE__, 'twd_user_info_uninstall');
function twd_user_info_uninstall()
{
    global $wpdb;
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $sql = 'DROP TABLE ' . $twd_user_info_table;
    $wpdb->query($sql);
    delete_option('twd_user_info_version');
    delete_option('twd_user_info_time_before_off');
}

/*
 * Code that automatically upgrades the plugin
 */

if (version_compare(get_option('twd_user_info_version'), '0.1.5', '<')) {
    twd_user_info_update();
}
function twd_user_info_update()
{
    global $wpdb;
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $sql = 'CREATE TABLE ' . $twd_user_info_table . ' (
  ip int(20) NOT NULL default \'0\',
  user_id bigint(20) default NULL,
  botname varchar(255) NOT NULL default \'\',
  path varchar(255) NOT NULL default \'\',
  first_visit bigint(20) NULL default NULL,
  last_visit bigint(20) NULL default NULL,
  view_count bigint(20) NOT NULL default \'0\',
  PRIMARY KEY (ip)
);';
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    update_option('twd_user_info_version', '0.1.5');
}

/*
 * Code for the admin page widget
 */

add_action('wp_dashboard_setup', 'twd_user_info_add_dashboard_widget');
function twd_user_info_add_dashboard_widget()
{
    wp_add_dashboard_widget('twd_user_info_dashboard_widget', __('tigaman User Info - ipinfo.io', 'twd-user-info'), 'twd_online_users_dashboard_widget');
}
function twd_online_users_dashboard_widget()
{
    global $wpdb;
    $members_s = '';
    $guests_text = '';
    $person = __('person', 'twd-user-info');
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $twd_user_info_table . ' WHERE user_id IS NULL;';
    $members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $twd_user_info_table . ';';
    $result = $wpdb->get_row($members_sql);
    $members = $result->user_count;
    $result2 = $wpdb->get_row($guests_sql);
    $guests = $result2->user_count;
    include $plugin_path . 'twd_user_info.php';
  // Your Infos
	echo '<div class="infolink"><a href="https://ipinfo.io/'.$ipAddress.'/json" target="_blank">Your information is here</a><br />'; 
// Add settings link
    echo '<a  href="' . admin_url('options-general.php?page=userinfo') . '">' . __('Settings', 'twd-user-info') . '</a></div>';	
}

    


/*
 * Code that handles the plugin options page
 */

add_action('admin_menu', 'twd_user_info_add_options_page');
function twd_user_info_add_options_page()
{
    if (function_exists('add_options_page')) {
        add_options_page('Online Users', __('User Info', 'twd-user-info'), 8, 'userinfo', 'twd_online_users_options_page');
    }
}
function twd_online_users_options_page()
{
    if (isset($_POST['minutes']) and !empty($_POST['minutes'])) {
        if (ctype_digit($_POST['minutes'])) {
            update_option('twd_user_info_time_before_off', $_POST['minutes']);
            echo '<div id="message" class="updated fade"><p><strong>' . __('Options saved', 'twd-user-info') . '</strong></p></div>';
        } else {
            echo '<div id="message" class="updated fade"><p><strong>' . __('You entered an invalid value', 'twd-user-info') . '</strong></p></div>';
        }
    }
    echo twd_user_info_output_options_page();
}
function twd_user_info_output_options_page()
{
    ?>
    <div class="wrap">
        <h2><?php _e('User Info', 'twd-user-info'); ?></h2>
        <form method="post">
            <fieldset class="options" name="general">
                <legend><?php _e('General settings', 'twd-user-info'); ?></legend>
                <table width="100%" cellspacing="2" cellpadding="5" class="editform">
                    <tr>
                        <th nowrap valign="top" width="33%"><?php _e('Hours Before Offline', 'twd-user-info'); ?></th>
                        <td><input type="text" name="minutes" id="minutes"
                                   value="<?php echo '' . get_option('twd_user_info_time_before_off') . '' ?>"/> <p
                                class="description">
  <?php _e('Determines how much time will pass before someone is considered offline. ', 'twd-user-info'); ?>


         </p>
                        </td>
                    </tr>
                </table>
            </fieldset>
            <p class="submit">
                <input type="submit" name="Submit" class="button-primary"
                       value="<?php _e('Save Changes', 'twd-user-info'); ?>"/>
            </p>
        </form>
       <hr />
        <h1 align="center">More great freebies</h1>
        <style type="text/css">
            #tigamandotcom {
                width: 100%;
                height: 800px;
                overflow-x: hidden;
            }

            .form-table th {
                display: flex;
                align-items: center;
            }

            .form-table input {
                width: 300px;
                padding: 10px;
            }

            .clear {
                clear: both;
            }

            #wpfooter {
                display: none;
            }
        </style>
        <div id="tigamandotcom">
            <embed type="text/html" src="https://www.tigaman.com/tigaman-webdesign-wordpress-plugins/" style="width: 100%; height: 800px;"></embed>


    </div>
    <?php
}

/*
 * Code for the visitor sidebar widget
 */


class twd_online_users_widget extends WP_Widget
{
    // Constructor
    public function __construct()
    {
        parent::__construct(
            'twd_online_users_widget',
            __('User Info - ipinfo.io'),
            array(
                'customize_selective_refresh' => true,
            )
        );
    }

// Widget form in the admin
public function form($instance)
{
    $title = !empty($instance['title']) ? $instance['title'] : __('User Info', 'twd-user-info');



    ?>
    <p>
        <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'twd-user-info'); ?></label>
        <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
               name="<?php echo $this->get_field_name('title'); ?>" type="text"
               value="<?php echo esc_attr($title); ?>">
    </p>
    <?php     // Add settings link
    echo '<p><a href="' . admin_url('options-general.php?page=userinfo') . '">' . __('Settings', 'twd-user-info') . '</a></p>';  ?>
    <?php
}

    // Widget display on the frontend
    public function widget($args, $instance)
    {
        $title = !empty($instance['title']) ? $instance['title'] : __('User Info - ipinfo.io', 'twd-user-info');

        echo $args['before_widget'];
        if (!empty($title)) {
            echo $args['before_title'] . apply_filters('widget_title', $title) . $args['after_title'];
        }

              global $wpdb;
    $members_s = '';
    $guests_text = '';
    $person = __('person', 'twd-user-info');
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $twd_user_info_table . ' WHERE user_id IS NULL;';
    $members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $twd_user_info_table . ';';
    $result = $wpdb->get_row($members_sql);
    $members = $result->user_count;
    $result2 = $wpdb->get_row($guests_sql);
    $guests = $result2->user_count;
    include $plugin_path . 'twd_user_info.php';

        echo $args['after_widget'];
    }
}

// Register the widget
function twdui_register_custom_widget()
{
    register_widget('twd_online_users_widget');
}

add_action('widgets_init', 'twdui_register_custom_widget');


/*
 * Code that handles logging activity
 */

add_action('get_header', 'twd_user_info_upload_activity');
add_action('admin_head', 'twd_user_info_upload_activity');

function twd_user_info_upload_activity()
{
    twd_user_info_cleanup();
    global $user_ID;
    if (twd_user_info_real_ip() == $_SERVER['SERVER_ADDR']) {
        return;
    } else {
        global $wpdb;
        $twd_user_info_table = $wpdb->prefix . 'user_online';
        $botname = twd_user_info_get_botname($_SERVER['HTTP_USER_AGENT']);
        if (empty($user_ID)) {
            $id = 'NULL';
        } else {
            $id = $wpdb->escape($user_ID);
        }
        $ip = ip2long(twd_user_info_real_ip());
        $sql = 'INSERT INTO ' . $twd_user_info_table . ' (ip, user_id, botname, path, first_visit, last_visit, view_count) VALUES (\'' . $ip . '\', ' . $id . ', \'' . $botname . '\', \'' . $wpdb->escape($_SERVER['REQUEST_URI']) . '\', ' . time() . ', ' . time() . ', 1) ON DUPLICATE KEY UPDATE path=\'' . $wpdb->escape($_SERVER['REQUEST_URI']) . '\', view_count=view_count+1, user_id=' . $id . ', last_visit = ' . time() . ';';
        $wpdb->query($sql);
    }
}

/*
 * Misc functions
 */
add_filter('the_author', 'twd_user_info_maybe_author');

function twd_user_info_maybe_author($username)
{
    global $wpdb;
    $check_online = $wpdb->get_results('SELECT t2.id AS id FROM ' . $wpdb->prefix . 'user_online AS t1 LEFT JOIN ' . $wpdb->prefix . 'users AS t2 ON t1.user_id = t2.id WHERE t2.user_login = \'' . $wpdb->escape($username) . '\';');
    if ($check_online) {
        $username = $username . ' (' . __('online', 'twd-user-info') . ')';
    }
    return $username;
}

function twd_user_info_real_ip()
{
    if ((isset($_SERVER['HTTP_X_FORWARDED_FOR']) && !empty($_SERVER['HTTP_X_FORWARDED_FOR'])) && long2ip(ip2long($_SERVER['HTTP_X_FORWARDED_FOR']))) {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } elseif (long2ip(ip2long($_SERVER['REMOTE_ADDR']))) {
        $ip = $_SERVER['REMOTE_ADDR'];
    } else {
        $ip = '127.0.0.1';
    }
    return $ip;
}

function twd_user_info_get_botname($user_agent)
{
    $bots = array('Alexa' => 'ia_archiver', 'All The Web' => 'FAST-WebCrawler', 'All The Web' => 'crawler@fast', 'Altavista' => 'Scooter', 'Ask.com' => 'Ask Jeeves/Teoma', 'DMOZ' => 'Robozilla', 'Exite' => 'Architext spider', 'Google' => 'Googlebot', 'Infoseek' => 'InfoSeek sidewinder', 'Inktomi' => 'Slurp', 'Look Smart' => 'MantraAgent', 'Lycos' => 'Lycos_Spider', 'MSN Search' => 'MSNbot', 'Teoma' => 'Teoma_agent', 'Yahoo' => 'Yahoo Slurp', 'Web Crawler' => 'WebCrawler', 'Wise Nut' => 'ZyBorg');
    if (empty($user_agent)) {
        $botname = '';
    } else {
        foreach ($bots as $bot => $bot_match) {
            if (stristr($user_agent, $bot_match)) {
                $botname = $bot;
                break;
            }
        }
    }
    return $botname;
}

function twd_user_info_time_convert($seconds)
{
    $time = '';
    if ($seconds > 3600) {
        $hours = ($seconds - ($seconds % 3600)) / 3600;
        $seconds = $seconds % 3600;
        $time .= $hours . ':';
    }
    $minutes = str_pad(($seconds - ($seconds % 60)) / 60, 2, 0, STR_PAD_LEFT);
    $seconds = str_pad($seconds % 60, 2, 0, STR_PAD_LEFT);
    $time .= $minutes . ':' . $seconds;
    return $time;
}

function twd_user_info_cleanup()
{
    global $wpdb;
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $hours = get_option('twd_user_info_time_before_off');
    $timeDifferenceInHours = $hours * 3600;
    $sql = 'DELETE FROM ' . $twd_user_info_table . ' WHERE (' . time() . '-' . $timeDifferenceInHours . ') > last_visit';
    $wpdb->query($sql);
}

function get_operating_system()
{
    $u_agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
    $operating_system = 'Unknown Operating System';

    // Get the operating_system name
    if ($u_agent) {
        if (preg_match('/linux/i', $u_agent)) {
            $operating_system = 'Linux';

            // Megpróbáljuk kinyerni a verziót is
            if (preg_match('/android\s([0-9.]+)/i', $u_agent, $matches)) {
                $operating_system .= ' ' . $matches[1];
            }
        } elseif (preg_match('/macintosh|mac os x|mac_powerpc/i', $u_agent)) {
            $operating_system = 'Mac';
        } elseif (preg_match('/windows\snt\s6.2/i', $u_agent)) {
            $operating_system = 'Windows 8';
        } elseif (preg_match('/windows\snt\s6.3/i', $u_agent)) {
            $operating_system = 'Windows 8.1';
        } elseif (preg_match('/windows\snt\s10.0/i', $u_agent)) {
            $operating_system = 'Windows 10';
        } elseif (preg_match('/windows\snt\s.*wow64/i', $u_agent)) {
            $operating_system = 'Windows 64-bit';
        } elseif (preg_match('/windows\snt\s11.0/i', $u_agent)) {
            $operating_system = 'Windows 11';
        } elseif (preg_match('/ubuntu/i', $u_agent)) {
            $operating_system = 'Ubuntu';
        } elseif (preg_match('/iphone/i', $u_agent)) {
            $operating_system = 'iPhone';
        } elseif (preg_match('/ipod/i', $u_agent)) {
            $operating_system = 'iPod';
        } elseif (preg_match('/ipad/i', $u_agent)) {
            $operating_system = 'iPad';
        } elseif (preg_match('/android/i', $u_agent)) {
            $operating_system = 'Android';
        } elseif (preg_match('/blackberry/i', $u_agent)) {
            $operating_system = 'Blackberry';
        } elseif (preg_match('/webos/i', $u_agent)) {
            $operating_system = 'Mobile';
        }
    } else {
        // Ha nem sikerült a felhasználói ügynök alapján azonosítani, próbáljuk meg az operációs rendszert
        // a php_uname() függvény segítségével lekérni.
        $operating_system = php_uname('s');
    }

    return $operating_system;
}

function enqueue_twd_user_info_css()
{
    wp_enqueue_style('twd-user-info-css', plugin_dir_url(__FILE__) . 'twd_user_info.css');
}

add_action('wp_enqueue_scripts', 'enqueue_twd_user_info_css');

function enqueue_twd_user_info_admin_css()
{
    wp_enqueue_style('twd-user-info-admin-css', plugin_dir_url(__FILE__) . 'twd_user_info.css');
}

add_action('admin_enqueue_scripts', 'enqueue_twd_user_info_admin_css');

function enqueue_twd_user_info_js()
{
    wp_enqueue_script('twd-user-info-js', plugin_dir_url(__FILE__) . 'twd_user_info.js', array(), false, true);
	wp_enqueue_script('twd-user-info-js-2', plugin_dir_url(__FILE__) . 'twd_user_info_2.js', array(), false, true);
}

add_action('wp_enqueue_scripts', 'enqueue_twd_user_info_js');

function enqueue_twd_user_info_admin_js()
{
    wp_enqueue_script('twd-user-info-admin-js', plugin_dir_url(__FILE__) . 'twd_user_info.js', array(), false, true);
    wp_enqueue_script('twd-user-info-admin-js-2', plugin_dir_url(__FILE__) . 'twd_user_info_2.js', array(), false, true);	
}

add_action('admin_enqueue_scripts', 'enqueue_twd_user_info_admin_js');

// Add settings link to the plugin page
function twd_user_info_settings_link($links)
{
    $settings_link = '<a href="' . admin_url('options-general.php?page=userinfo') . '">' . __('Settings', 'twd-user-info') . '</a>';
    array_unshift($links, $settings_link);
    return $links;
}

$plugin_basename = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin_basename", 'twd_user_info_settings_link');
// Dashboard Widget
function zizu_add_dashboard_widget()
{
    wp_add_dashboard_widget('zizu_dashboard_widget', __('tigaman User Info - findip.net', 'twd-user-info'), 'zizu_online_users_dashboard_widget');
}

function zizu_online_users_dashboard_widget()
{
    global $wpdb;
    $members_s = '';
    $guests_text = '';
    $person = __('person', 'twd-user-info');
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $twd_user_info_table . ' WHERE user_id IS NULL;';
    $members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $twd_user_info_table . ';';
    $result = $wpdb->get_row($members_sql);
    $members = $result->user_count;
    $result2 = $wpdb->get_row($guests_sql);
    $guests = $result2->user_count;
    include $plugin_path . 'twd_user_info_2.php';
  // Your Infos
	echo '<div class="infolink"><a href="https://api.findip.net/'.$ip.'/?token='.$token.'" target="_blank">Your information is here</a><br />'; 
// Add settings link
    echo '<a href="' . admin_url('options-general.php?page=userinfo') . '">' . __('Settings', 'twd-user-info') . '</a></div>';	
}


add_action('wp_dashboard_setup', 'zizu_add_dashboard_widget');

// Sidebar Widget
class zizu_online_users_widget extends WP_Widget
{
    // Constructor
    public function __construct()
    {
        parent::__construct(
            'zizu_online_users_widget',
            __('User Info - findip.net', 'zizu-user-info'), // Widget name
            array(
                'customize_selective_refresh' => true,
            )
        );
    }

    // Widget form in the admin
    public function form($instance)
    {
        // Widget settings form
        $title = !empty($instance['title']) ? $instance['title'] : __('User Info', 'zizu-user-info');
        ?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'zizu-user-info'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
                   name="<?php echo $this->get_field_name('title'); ?>" type="text"
                   value="<?php echo esc_attr($title); ?>">
        </p>
        <?php
    }

    // Widget display on the frontend
    public function widget($args, $instance)
    {
        $title = !empty($instance['title']) ? $instance['title'] : __('User Info - findip.net', 'zizu-user-info');

       echo $args['before_widget'];
        if (!empty($title)) {
            echo $args['before_title'] . apply_filters('widget_title', $title) . $args['after_title'];
        }

              global $wpdb;
    $members_s = '';
    $guests_text = '';
    $person = __('person', 'twd-user-info');
    $twd_user_info_table = $wpdb->prefix . 'user_online';
    $guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $twd_user_info_table . ' WHERE user_id IS NULL;';
    $members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $twd_user_info_table . ';';
    $result = $wpdb->get_row($members_sql);
    $members = $result->user_count;
    $result2 = $wpdb->get_row($guests_sql);
    $guests = $result2->user_count;
    include $plugin_path . 'twd_user_info_2.php';

        echo $args['after_widget'];
    }
}

// Register the widget
function zizu_register_custom_widget()
{
    register_widget('zizu_online_users_widget');
}

add_action('widgets_init', 'zizu_register_custom_widget');

?>